=== src/events/CMakeLists.txt ===
file(GLOB WL_EVENTS_SRCS *.cc)

add_library(widelands_events ${WL_EVENTS_SRCS})
