=== src/game_io/CMakeLists.txt ===
file(GLOB WL_GAME_IO_SRCS *.cc)

add_library(widelands_game_io ${WL_GAME_IO_SRCS})
