=== debian/changelog ===
widelands (1:15-3squeeze2) stable; urgency=low

  * Fix network play on official maps (bug introduced by patches/secfix-617960)
    Added: patches/secfix-617960-aux (Closes: #624316)

 -- Enrico Tassi <gareuselesinge@debian.org>  Wed, 17 Aug 2011 21:12:34 +0200

widelands (1:15-3squeeze1) stable; urgency=high

  * Closes a potential security issue in internet games.
    Added: patches/secfix-617960 (Closes: #617960)

 -- Enrico Tassi <gareuselesinge@debian.org>  Tue, 19 Apr 2011 14:35:07 +0200
