=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	mkdir -p build-debian
	cd build-debian; cmake \
		-DWL_INSTALL_PREFIX=/usr \
		-DWL_INSTALL_DATADIR=share/games/widelands \
		-DWL_INSTALL_BINDIR=games \
		-DWL_INSTALL_LOCALEDIR=share/games/widelands/locale \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DCMAKE_INSTALL_DATADIR=share/games/widelands \
		-DCMAKE_INSTALL_BINDIR=games \
		-DCMAKE_INSTALL_LOCALEDIR=share/games/widelands/locale \
		-DCMAKE_BUILD_TYPE=Release \
		-DWL_VERSION_MAJOR=0 \
		-DWL_VERSION_MINOR=15 \
		-DWL_VERSION_ADDITION=RC1 \
		../; cat src/config.h

override_dh_auto_build:
	cd build-debian; make all

override_dh_auto_install:
	cd build-debian; make install DESTDIR=`pwd`/../debian/tmp
	mkdir -p  debian/tmp/usr/share/applications/
	cp debian/widelands.desktop debian/tmp/usr/share/applications/
	rm debian/tmp/usr/share/games/widelands/fonts/FreeSans.ttf
	rm debian/tmp/usr/share/games/widelands/fonts/FreeSerif.ttf
	rm debian/tmp/usr/share/games/widelands/fonts/Widelands/LICENSE
	cd debian/tmp/usr/share/games/widelands/fonts/; ln -s /usr/share/fonts/truetype/freefont/FreeSans.ttf 
	cd debian/tmp/usr/share/games/widelands/fonts/; ln -s /usr/share/fonts/truetype/freefont/FreeSerif.ttf 

override_dh_strip:
	dh_strip --dbg-package=widelands-dbg
